
-module(link2).
-export([start/0, child_process/0]).


% shows 2-way links, here child lives longer than the
% parent and when the parent ends normally, the child
% continues executing

start() ->
    % Parent process continues running after child finishes
    io:format("Parent>> process begins running.~n"),

    % Parent process spawns and links to the child process
    ChildPid = spawn_link(?MODULE, child_process, []),
    io:format("Parent>> process has spawned and linked to child.~n"),


    % Wait for a while before ending
    timer:sleep(1000),
    io:format("Parent>> process is still running.~n"),
    timer:sleep(1000),
    io:format("Parent>> process is still running.~n"),
    timer:sleep(1000),
    io:format("Parent>> process is still running.~n"),
    timer:sleep(1000),
    io:format("Parent>> process exiting normally.~n").

child_process() ->
    io:format("Child>> process is running.~n"),
    timer:sleep(4000),
    io:format("Child>> process is running.~n"),
    timer:sleep(4000),
    io:format("Child>> process is running.~n"),
    timer:sleep(4000),
    io:format("Child>> process is running.~n"),

    % Child process finishes normally
    io:format("Child process exiting normally.~n").

    % a normal exit signal is sent to parent, and since its normal
    % the parent ignores it and keep going

