
%% File: hotU2.erl

-module(hotUS3).
-export([start/0, stop/1, send_message/2, loop/0]).

%% Start the server
start() ->
    Pid = spawn(fun() -> loop() end),
    {ok, Pid}.

%% The server loop 
loop() ->
    receive
        update ->
            io:format("Hot swapping to new version of code (v1)~n"),
            ?MODULE:loop();  %% This triggers the hot code reload
        hello ->
            io:format("Received 'hello' message in v1~n"),
            loop();
        stop ->
            io:format("Stopping server (v1)~n"),
            ok;
        TrapAllMsg ->
            io:format("Received random message: ~p in v1~n", [TrapAllMsg]),
            loop()
    end.


%% Stop the server by sending a 'stop' message
stop(Pid) ->
    Pid ! stop,
    ok.

%% Send a message to the server
send_message(Pid, Message) ->
    Pid ! Message,
    ok.
